﻿/**
あ
*/
module nemuxi.gui.window.dialog.commanddialog.commanddialog;

debug import std.stdio: wl = writefln, pl = printf;
debug(commanddialog) void main() {}

import win32.windows;

import etc.kareki.kareki;

import nemuxi.base;
import nemuxi.system.application;
import nemuxi.file.app;
import nemuxi.file.items.item;
import nemuxi.file.items.items;
import nemuxi.file.items.itemfunc;
import nemuxi.negui.draw.unit;
import nemuxi.negui.draw.imagelist;
import nemuxi.image.icon;
import nemuxi.image.font;
import nemuxi.negui.negui;
import nemuxi.negui.window.newindow;
import nemuxi.negui.window.dialog.dialog;
import nemuxi.negui.control.editbox.editbox;
import nemuxi.negui.control.button.button;
import nemuxi.negui.control.listbox.listbox;
import nemuxi.negui.control.label.label;
import nemuxi.gui.control.titlebar;
import nemuxi.negui.subclass;
import nemuxi.gui.window.dialog.commanddialog.commandedit;
import nemuxi.system.raii;


class CommandDialog: ModelessDialog {
	private enum CTRL: ITEM_ID {
		TITLE = 1,
		INPUT,
	}
	private {
		TitleBar Titlebar;
		CommandEdit Input;
	}
	private {
		Application application;
		Font CtrlFont;
		ICONSIZE IconSize;
		Kareha ItemTree;
		COMMANDCOLOR[] CommandColors;
	}
	this(NeWindow Owner, Application application) {
		this.application = application;
		
		GUIINFO NeGuiInfo;
		NeGuiInfo.Style        = WS_DLGFRAME | WS_SIZEBOX;
		NeGuiInfo.ExStyle      = WS_EX_DLGMODALFRAME | WS_EX_TOOLWINDOW;
		NeGuiInfo.Owner = Owner;

		// application
		CtrlFont = application.AppData.exeCommandFont();
		IconSize = application.AppData.exeCommandIcon();
		ItemTree = application.itemBase;

		
		for(auto i=App.COMMANDCOLOR.min; i < App.COMMANDCOLOR.max+1; i++) {
			auto Colors=application.AppData.exeCommandColor(i);
			COMMANDCOLOR CommandColor;
			CommandColor.left  = Colors[0];
			CommandColor.right = Colors[1];
			CommandColors ~= CommandColor;
		}
		
		super(&NeGuiInfo, MAINLOOP_KEY);
	}
	
	protected override {
		void OnActive(WINDOW_ACTIVE Active, bool NotSmall, HWND NextWnd) {
			super.OnActive(Active, NotSmall, NextWnd);
			Titlebar.onActive(Active);

			if(Active == WINDOW_ACTIVE.INACTIVE) {
				Input.toHide;
			} else {
				Input.upDate(Input.text);
			}
		}
		
		void OnCreate() {
			super.OnCreate();

			frameSize=true;

			
			Titlebar = new TitleBar(this, CTRL.TITLE);
			Titlebar.Position = TitleBar.POSITION.LEFT;


			Input = new CommandEdit(this, CTRL.INPUT, loopOwnerID, ItemTree, IconSize, CommandColors);
			Input.font = CtrlFont;
			Input.text = Text.emptyText;
			
			adjustSize(120, GetDefaultControlHeight(CtrlFont));
		}

		bool OnClose() {
			setShow(SHOW.HIDE);
			return false;
		}
		void OnShowWindow(bool Show, SHOW_FLAG Flag) {
			if(Show) {
				Input.tuneList;
				
				foreGround;
				Input.setFocus;
			} else {
				Input.text = Text.emptyText;
				Input.toHide;
			}
		}
		
		void OnDestroy() {
			Titlebar.destroy;
			Input.destroy;
			delete CtrlFont;
			super.OnDestroy();
		}
		void OnExitSizeMove() {
			Input.tuneList;
			
			foreGround;
			Input.setFocus;
		}

		bool OnSize(SIZE_TYPE SizeType, int Width, int Height) {
			Titlebar.onSize();

			Input.move(Titlebar.getSize, 0, Width - Titlebar.getSize, Height);
			Input.tuneList;

			return false;
		}

		void OnDrawItem(ITEM_ID Id, DRAWITEM* DrawItem) {
			switch(DrawItem.type) {
				case CONTROL_TYPE.BUTTON: // タイトルボタン
					assert(DrawItem.id == CTRL.TITLE);
					Titlebar.draw(DrawItem);
					break;
				default:
					assert(false);
			}
		}

		bool OnOtherEvent(UINT Message, WPARAM wParam, LPARAM lParam) {
			if(Message == WM_MY_ITEM) {
				if(auto pCommand = cast(COMMANDVALUE*)lParam) {
					final switch(pCommand.type) {
						case COMMANDVALUE.TYPE.ITEM:
							application.executeItem(pCommand.CItem.item);
							break;
						case COMMANDVALUE.TYPE.TEXT:
							assert(false);
					}

					//スマートにしないと
					this.setShow(SHOW.HIDE);
					
					return true;
				}
			}
			
			return super.OnOtherEvent(Message, wParam, lParam);
		}
	}
}


